//+--------------------------------------------------------------------------------------------+
//|   Klinger.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Gray
#property indicator_color3  Gold

extern int FastX   = 34;
extern int SlowX   = 55;
extern int TrigLen = 13;
extern int Smooth  = 1;

double KVO[];
double KVOl[];
double Signal[];

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
      
   SetIndexBuffer(0,KVO);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,KVOl);
   SetIndexBuffer(2,Signal); 
      Smooth = MathMax(Smooth,1);
   return(0);
}
int deinit() { return(0); }

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

double work[][6];
#define _TSum   0
#define _Trend  1
#define _CM     2
#define _VForce 3
#define _Kvo    4
#define _Triger 5

int start()
{
  int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_TSum]  = High[i]+Low[i]+Close[i];
      work[r][_Trend] = work[r-1][_Trend] ;
         if (work[r][_TSum] > work[r-1][_TSum]) work[r][_Trend] =  1;
         if (work[r][_TSum] < work[r-1][_TSum]) work[r][_Trend] = -1;
         if (work[r][_Trend] == work[r-1][_Trend])
               work[r][_CM] = High[i] - Low[i] + work[r-1][_CM];
         else  work[r][_CM] = High[i] - Low[i] + High[i+1] - Low[i+1];
         
         //
         //
         //
         //
         //
         
         double dm = 0; if ((Low[i]-Low[i+1])<0) dm = -(Low[i]-Low[i+1]);
            if (work[r][_CM]!= 0)
                  work[r][_VForce] = Volume[i]*MathAbs(2*dm/work[r][_CM]-1)*work[r][_Trend]*100.0;
            else  work[r][_VForce] = work[r-1][_VForce];
         work[r][_Kvo]    = iEma(work[r][_VForce],FastX,i,0)-iEma(work[r][_VForce],SlowX,i,1);
         work[r][_Triger] = iEma(work[r][_Kvo],TrigLen,i,2);
         
         //
         //
         //
         //
         //

         KVO[i]    = 0;
         Signal[i] = 0;
         for (int k= 0; k<Smooth && (r-k)>=0; k++)
            {
               KVO[i]    += work[r-k][_Kvo];
               Signal[i] += work[r-k][_Triger];
            }
            KVOl[i] = KVO[i];
   }
   return(0);

}

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

double workEma[][3];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

